#!/usr/local/bin/python3
from glib import *

def dfs(graph, visit, node, parent) :
    print(node)
    visit[node] = True
    for n in graph[node] :
        if visit[n]==False : dfs(graph, visit, n, node)
        elif n!=parent and parent!=None : print("NOT TREE", node, n)

print("NOT TREE DIGRAPH")
visit = array(len(notTree), False)
dfs(notTree, visit, 0, None)

print("NOT TREE GRAPH")
visit = array(len(notTreeGraph), False)
dfs(notTreeGraph, visit, 0, None)

print("TREE GRAPH")
visit = array(len(tree), False)
dfs(tree, visit, 0, None)


# TEST THE ISTREE IDEA

# simple depth first search in a graph or digraph
def isTree(graph) :
    visit = array(len(graph), False)
    isTreeAux(graph, visit, 0, None)
    return all(visit)

def isTreeAux(graph, visit, node, parent) :
    visit[node] = True
    for n in graph[node] :
        if visit[n]==False : isTreeAux(graph, visit, n, node)
        elif n!=parent and parent!=None : print("NOT TREE", node, n)


print("NOT TREE DIGRAPH")
visit = array(len(notTree), False)
isTree(notTree)

print("NOT TREE GRAPH")
visit = array(len(notTreeGraph), False)
isTree(notTreeGraph)

print("TREE GRAPH")
isTree(tree)



## ## ## ## ## ## ## ## ## ## ## ## ## ## ## 
# USE DFS TO MAKE A ISTREE PREDICATE

def isTree(graph, node) :
    visit = array(len(graph), False)
    return isTreeAux(graph, visit, node, None)

def isTreeAux(graph, visit, node, parent) :
    visit[node] = True
    for n in graph[node] :
        if visit[n]==False : 
            if isTreeAux(graph, visit, n, node)==False : return False
        elif n!=parent and parent!=None : return False
    return True


print("notTree DIGRAPH (node 0)")
visit = array(len(notTree), False)
print(isTree(notTree, 0))

print("notTree DIGRAPH (node 5)")
visit = array(len(notTree), False)
print(isTree(notTree, 5))

print("notTreeGraph GRAPH (node 0)")
visit = array(len(notTreeGraph), False)
print(isTree(notTreeGraph, 0))

print("notTreeGraph GRAPH (node 5)")
visit = array(len(notTreeGraph), False)
print(isTree(notTreeGraph, 5))

print("tree GRAPH (node 0)")
print(isTree(tree, 0))

print("tree GRAPH (node 5)")
print(isTree(tree, 0))


