#!/usr/local/bin/python3

# digraphs have directional pointers from node x to y but do 
# not require that there be a pointer from y to x

# as dictionary/lists
digraph = {"a" : ["b", "c", "d"], 
         "b" : [], 
         "c" : ["e", "f"], 
         "d" : ["f"], 
         "e" : [],
         "f" : ["i"],
         "g" : ["h"],
         "h" : [],
         "i" : []
         }

print(digraph["a"])

# as lists/lists
digraph = [[1, 2, 3], # 0
          [],        # 1
          [4, 5],    # 2
          [5],       # 3
          [],        # 4
          [8],       # 5
          [7],       # 6
          [],        # 7
          []
          ]
          
print(digraph[0])

# as dictionary/sets
digraph = {"a" : {"b", "c", "d"}, 
         "b" : set(), 
         "c" : {"e", "f"}, 
         "d" : {"f"}, 
         "e" : set(),
         "f" : {"i"},
         "g" : {"h"},
         "h" : set(),
         "i" : set()
         }

print(digraph["a"])

# as list/sets
digraph = [{1, 2, 3}, # 0
          set(),       # 1
          {4, 5},      # 2
          {5},         # 3
          set(),       # 4
          {8},         # 5
          {7},         # 6
          set(),       # 7
          set()        # 8
          ]
          
print(digraph[0])
