#!/usr/local/bin/python3
from somegraphs import *

def preorder(g, node, visitf) :
    visitf(g, node)
    for i in g[node]:
        preorder(g, i, visitf)

def postorder(g, node, visitf) :
    for i in g[node]:
        postorder(g, i, visitf)
    visitf(g, node)

def inorder(g, node, visitf) :
    if len(g[node])==0 : 
        visitf(g, node)
    else :
        glist = list(g[node])
        for i in range(0, len(glist)-1) :
            inorder(g, glist[i], visitf)
            visitf(g, node)
        inorder(g, glist[-1], visitf)


treefullbinD = [{1, 2}, {3, 4}, {5, 6}, set(), set(), set(), set()]
nodes = ["*", "+", "-", "X", "Y", "A", "B"]
print("           0 ")
print("          / \ ")
print("         /   \ ")
print("        1     2 ")
print("       / \   / \   ")
print("      3   4 5   6 ")

def v(g, node) :
    print(nodes[node], end="")


print("PRE")
preorder(treefullbinD, 0, v)
print()
print("IN")
inorder(treefullbinD, 0, v)
print()
print("POST")
postorder(treefullbinD, 0, v)
print()


